QuantLib: InterestRateVolSurface Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

List of all members
InterestRateVolSurface Class Reference

Interest rate volatility (smile) surface. More...

`#include <ql/experimental/volatility/interestratevolsurface.hpp>`

Inheritance diagram for InterestRateVolSurface:
[legend]

## Public Member Functions
Constructors
See the TermStructure documentation for issues regarding constructors.
| InterestRateVolSurface (const ext::shared_ptr< InterestRateIndex > &, BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| InterestRateVolSurface (const ext::shared_ptr< InterestRateIndex > &, const Date &referenceDate, const Calendar &cal=Calendar(), BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| InterestRateVolSurface (const ext::shared_ptr< InterestRateIndex > &, Natural settlementDays, const Calendar &, BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
VolatilityTermStructure interface
Date | optionDateFromTenor (const Period &) const
| period/date conversion
const ext::shared_ptr< InterestRateIndex > & | index () const
Public Member Functions inherited from BlackVolSurface
| BlackVolSurface (BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| default constructor More...
| BlackVolSurface (const Date &referenceDate, const Calendar &cal=Calendar(), BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| BlackVolSurface (Natural settlementDays, const Calendar &, BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
ext::shared_ptr< SmileSection > | smileSection (const Period &, bool extrapolate) const
| returns the smile for a given option tenor
ext::shared_ptr< SmileSection > | smileSection (const Date &, bool extrapolate) const
| returns the smile for a given option date
ext::shared_ptr< SmileSection > | smileSection (Time, bool extrapolate) const
| returns the smile for a given option time
Public Member Functions inherited from BlackAtmVolCurve
| BlackAtmVolCurve (BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| default constructor More...
| BlackAtmVolCurve (const Date &referenceDate, const Calendar &cal=Calendar(), BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| BlackAtmVolCurve (Natural settlementDays, const Calendar &, BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~BlackAtmVolCurve ()
Volatility | atmVol (const Period &optionTenor, bool extrapolate=false) const
| spot at-the-money volatility
Volatility | atmVol (const Date &maturity, bool extrapolate=false) const
| spot at-the-money volatility
Volatility | atmVol (Time maturity, bool extrapolate=false) const
| spot at-the-money volatility
Real | atmVariance (const Period &optionTenor, bool extrapolate=false) const
| spot at-the-money variance
Real | atmVariance (const Date &maturity, bool extrapolate=false) const
| spot at-the-money variance
Real | atmVariance (Time maturity, bool extrapolate=false) const
| spot at-the-money variance
Public Member Functions inherited from VolatilityTermStructure
| VolatilityTermStructure (BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| VolatilityTermStructure (const Date &referenceDate, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| VolatilityTermStructure (Natural settlementDays, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual BusinessDayConvention | businessDayConvention () const
| the business day convention used in tenor to date conversion
Date | optionDateFromTenor (const Period &) const
| period/date conversion
virtual Rate | minStrike () const =0
| the minimum strike for which the term structure can return vols
virtual Rate | maxStrike () const =0
| the maximum strike for which the term structure can return vols
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~TermStructure ()
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Date | maxDate () const =0
| the latest date for which the curve can return values
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## Visitability
ext::shared_ptr< InterestRateIndex > | index_
virtual void | accept (AcyclicVisitor &)

## Additional Inherited Members
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from BlackVolSurface
Real | atmVarianceImpl (Time t) const
| spot at-the-money variance calculation
Volatility | atmVolImpl (Time t) const
| spot at-the-money volatility calculation
virtual ext::shared_ptr< SmileSection > | smileSectionImpl (Time) const =0
Calculations
These methods must be implemented in derived classes to perform the actual volatility calculations. When they are called, range check has already been performed; therefore, they must assume that extrapolation is required.
Protected Member Functions inherited from VolatilityTermStructure
void | checkStrike (Rate strike, bool extrapolate) const
| strike-range check
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_

## Detailed Description

Interest rate volatility (smile) surface.

This abstract class defines the interface of concrete Interest rate volatility (smile) surfaces which will be derived from this one.

Volatilities are assumed to be expressed on an annual basis.

## Constructor & Destructor Documentation

## ◆ InterestRateVolSurface()

InterestRateVolSurface | ( | const ext::shared_ptr< InterestRateIndex > & | ,
|  | BusinessDayConvention | bdc = `Following`,
|  | const DayCounter & | dc = `DayCounter()`
| ) |  |
| explicit

Warning:
  term structures initialized by means of this constructor must manage their own reference date by overriding the referenceDate() method.